Class | Haml::HTML::ERB
In: | lib/haml/html/erb.rb
Parent: | Erubis::Basic::Engine

A class for converting ERB code into a format that‘s easier for the {Haml::HTML} Hpricot-based parser to understand.

Uses [Erubis](www.kuwata-lab.com/erubis)'s extensible parsing powers to parse the ERB in a reliable way, and [ruby_parser](parsetree.rubyforge.org/)'s Ruby knowledge to figure out whether a given chunk of Ruby code starts a block or not.

The ERB tags are converted to HTML tags in the following way. `<% … %>` is converted into `<haml:silent> … </haml:silent>`. `<%= … %>` is converted into `<haml:loud> … </haml:loud>`. Finally, if either of these opens a Ruby block, `<haml:block> … </haml:block>` will wrap the entire contents of the block - that is, everything that should be indented beneath the previous silent or loud tag.

### Methods

add_expr_debug add_expr_literal add_postamble add_preamble add_stmt add_text compile escaped_expr

### Public Class methods

compile(template)

Compiles an ERB template into a HTML document containing `haml:` tags.

@param template [String] The ERB template @return [String] The output document @see Haml::HTML::ERB

[Source]

        # File lib/haml/html/erb.rb, line 27
    27:       def self.compile(template)
    28:         new(template).src
    29:       end

### Public Instance methods

add_expr_debug(src, code)

`html2haml` doesn‘t support debugging expressions.

[Source]

        # File lib/haml/html/erb.rb, line 81
    81:       def add_expr_debug(src, code)
    82:         raise Haml::Error.new("html2haml doesn't support debugging expressions.")
    83:       end

add_expr_literal(src, code)

Concatenates a Ruby expression that‘s printed to the document onto the source buffer. This uses the `<haml:silent>` tag, and may open a Ruby block with the `<haml:block>` tag. An expression never closes a block.

@param src [String] The source buffer @param code [String] The Ruby expression to add to the buffer

[Source]

        # File lib/haml/html/erb.rb, line 75
    75:       def add_expr_literal(src, code)
    76:         src << '<haml:loud>' << h(code) << '</haml:loud>'
    77:         src << '<haml:block>' if block_opener?(code)
    78:       end

add_postamble(src)

The ERB-to-Hamlized-HTML conversion has no postamble.

[Source]

        # File lib/haml/html/erb.rb, line 40
    40:       def add_postamble(src); end

add_preamble(src)

The ERB-to-Hamlized-HTML conversion has no preamble.

[Source]

        # File lib/haml/html/erb.rb, line 37
    37:       def add_preamble(src); end

add_stmt(src, code)

Concatenates a silent Ruby statement onto the source buffer. This uses the `<haml:silent>` tag, and may close and/or open a Ruby block with the `<haml:block>` tag.

In particular, a block is closed if this statement is some form of `end`, opened if it‘s a block opener like `do`, `if`, or `begin`, and both closed and opened if it‘s a mid-block keyword like `else` or `when`.

@param src [String] The source buffer @param code [String] The Ruby statement to add to the buffer

[Source]

        # File lib/haml/html/erb.rb, line 61
    61:       def add_stmt(src, code)
    62:         src << '</haml:block>' if block_closer?(code) || mid_block?(code)
    63:         src << '<haml:silent>' << h(code) << '</haml:silent>' unless code.strip == "end"
    64:         src << '<haml:block>' if block_opener?(code) || mid_block?(code)
    65:       end

add_text(src, text)

Concatenates the text onto the source buffer.

@param src [String] The source buffer @param text [String] The raw text to add to the buffer

[Source]

        # File lib/haml/html/erb.rb, line 46
    46:       def add_text(src, text)
    47:         src << text
    48:       end

escaped_expr(code)

`html2haml` doesn‘t support HTML-escaped expressions.

[Source]

        # File lib/haml/html/erb.rb, line 32
    32:       def escaped_expr(code)
    33:         raise Haml::Error.new("html2haml doesn't support escaped expressions.")
    34:       end

[Validate]